package HT.fx;

import fi.jyu.mit.fxgui.CheckBoxChooser;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.DatePicker;
import javafx.scene.control.MenuButton;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.stage.Stage;

/**
 * @author joonatan, tuomas
 * @version 13.3.2024
 *
 */
public class PadelLisaaOtteluGUIController implements ModalControllerInterface<String> {
    
    @FXML private Button OKButton;

    @FXML private ComboBoxChooser<String> menuOsallistuja1;

    @FXML private ComboBoxChooser<String> menuOsallistuja2;

    @FXML private ComboBoxChooser<String> menuOsallistuja3;

    @FXML private ComboBoxChooser<String> menuOsallistuja4;

    @FXML private ComboBoxChooser<String> menuVoittaja1;

    @FXML private ComboBoxChooser<String> menuVoittaja2;

    @FXML private DatePicker otteluPvm;

    @FXML private TextField textLopputulos;

    @FXML void handleOk() {
        kasitteleOk();
        Stage stage = (Stage) OKButton.getScene().getWindow();
        stage.close();
    }

    /**
     * Tällä hetkellä ei poista mitään, vaan toimii käytännössä päivitä nappina
     */
    @FXML void handlePoista() {
        /*alusta(menuOsallistuja1);
        alusta(menuOsallistuja2);
        alusta(menuOsallistuja3);
        alusta(menuOsallistuja4);
        alusta(menuVoittaja1);
        alusta(menuVoittaja2);
        Dialogs.showMessageDialog("Ei osata vielä");*/
        
        
        alustamuokkaus();
        
    }
    //=======================================================
    
    /**
     * Lisää vaihtoehdot parametrina annetulle valintamenulle
     * @param menu mihin menuun lisätään
     */
    private void alusta(ComboBoxChooser<String> menu) {
        menu.clear();
        int i = 1;
        
        int lukumaara = PadelMainGUIController.getKarkelo().getPelaajia();
        while(i<= lukumaara) {
            menu.add(PadelMainGUIController.getKarkelo().annaPelaaja(i).getNimi(), null);
            i++;
        }
    }
    
    /**
     * muokattavan ottelun id
     */
    public int muok = OtteluIkkunaGUIController.muokattava;
    
    private void alustamuokkaus() {
        alusta(menuOsallistuja1);
        alusta(menuOsallistuja2);
        alusta(menuOsallistuja3);
        alusta(menuOsallistuja4);
        alusta(menuVoittaja1);
        alusta(menuVoittaja2);
        
        Ottelu ott = PadelMainGUIController.getKarkelo().noudaOttelu(muok);
        
        int numerot[] = ott.getPelaajaNrot();
        System.out.println(numerot[0] +" "+ numerot[1]+" "+ numerot[2]+" "+numerot[3]+"");
        
        
        menuOsallistuja1.setSelectedIndex(numerot[0]-1);
        menuOsallistuja2.setSelectedIndex(numerot[1]-1);
        menuOsallistuja3.setSelectedIndex(numerot[2]-1);
        menuOsallistuja4.setSelectedIndex(numerot[3]-1);
        menuVoittaja1.setSelectedIndex(ott.getVoittajaNro1()-1);
        menuVoittaja2.setSelectedIndex(ott.getVoittajaNro2()-1);
        
        textLopputulos.setText(ott.getLopputulos());
        
        otteluPvm.setValue(ott.getDate());
        
        
        
        
        
    }
    
    /**
     * Käsittelee ok napin. Hakee jokaisen valitun indeksin ja tekee 
     * näistä ottelun main controllerin karkeloon
     */
    public void kasitteleOk() {
        //String pvm = datesyntaika.getValue().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        int PelaajaNro1 = menuOsallistuja1.getSelectedIndex()+1;
        int PelaajaNro2 = menuOsallistuja2.getSelectedIndex()+1;
        int PelaajaNro3 = menuOsallistuja3.getSelectedIndex()+1;
        int PelaajaNro4 = menuOsallistuja4.getSelectedIndex()+1;
        int VoittajaNro1 = menuVoittaja1.getSelectedIndex()+1;
        int VoittajaNro2 = menuVoittaja2.getSelectedIndex()+1;
        String lopputulos = textLopputulos.getText();
        
        if(muok<0) {
            Ottelu uusi = new Ottelu(otteluPvm.getValue(), PelaajaNro1, PelaajaNro2, PelaajaNro3, PelaajaNro4, VoittajaNro1, VoittajaNro2, lopputulos);
        
            PadelMainGUIController.LisaaOttelu(uusi); // lisää ottelun karkeloon
        }
        
        if(muok>=0) {
            Ottelu ott = PadelMainGUIController.getKarkelo().noudaOttelu(muok);
            ott.setpelaajaNro1(PelaajaNro1);
            ott.setpelaajaNro2(PelaajaNro2);
            ott.setpelaajaNro3(PelaajaNro3);
            ott.setpelaajaNro4(PelaajaNro4);
            ott.setvoittajaNro1(VoittajaNro1);
            ott.setvoittajaNro2(VoittajaNro2);
            ott.setPvm(otteluPvm.getValue());
            ott.setLopputulos(lopputulos);
            
        }
        PadelMainGUIController.getKarkelo().paivitaRankingit();
        
        OtteluIkkunaGUIController.muokattava = -1;
        
        
        
    }
    
    @Override
    public String getResult() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
        
    }

    @Override
    public void setDefault(String arg0) {
        // TODO Auto-generated method stub
        
    }
}
